<?
 require_once($_path["include"]."errors.php");
 require_once($_path["include"]."mutilate.php");
 require_once($_path["project"]["plugins"]."calendar/grid.php");

 class Timeline
 {
  function __construct($format=false)
  {
   if($format)
    $this->format=$format;
   else
    $this->format="h:i:s d-m-Y";

   $this->mutilate=new Mutilate();
   $this->grid=new Grid("timeline");

   $this->e=&$this->grid->e; //share error object

   $this->clear();
  }

  function clear()
  {
   $this->grid->clear();
   $this->grid->setSection("header");
  }

  function style($inline=false)
  {
   global $_path;

   if($inline)
    $r="<style type=\"text/css\">".file_get_contents($_path["project"]["plugins"]."calendar/style/default.css")."</style>";
   else
    $r="<link rel=\"stylesheet\" type=\"text/css\" href=\"".$_path["HTML"]["current"].$_path["project"]["plugins"]."calendar/style/default.css\"/>";

   return $r;
  }

  function event($section, $title, $start, $end, $text=false, $class=false)
  {
   $sectionKey=preg_replace("/[^a-z0-9]/", "", $this->mutilate->changeCase($section, "lower"));

   if(($startTS=$this->mutilate->dateConvert($start, $this->format))===false)
   {
    $this->e->add("Unable to convert start date \"".$start."\" for \"".$title."\"", "error");
    return false;
   }

   if(($endTS=$this->mutilate->dateConvert($end, $this->format))===false)
   {
    $this->e->add("Unable to convert end date \"".$end."\" for \"".$title."\"", "error");
    return false;
   }

   if($this->grid->isSection($sectionKey)===false)
   {
    if(!$this->grid->setSection($sectionKey))
     return false;

    if(!$this->grid->setBefore($section))
     return false;
   }

   //swap start and end if start is later than end
   if($startTS>$endTS)
   {
    $tmp=$startTS;
    $startTS=$endTS;
    $endTS=$tmp;
    unset($tmp);
   }

   if($this->grid->setEntry($title, $startTS, $endTS, $sectionKey)===false)
    return false;

   if($text)
   {
    if(!$this->grid->setTooltip($text, $sectionKey))
     return false;
   }

   if($class)
   {
    if(!$this->grid->setClass($class, $sectionKey))
     return false;
   }

   return true;
  }

  function render($start=false, $end=false, $interval=false, $intervalHeader=false, $type=false, $headerFormat=false)
  {
   if($start===false)
    $startTS=$this->grid->getStart();
   else if(($startTS=$this->mutilate->dateConvert($start, $this->format))===false)
   {
    $this->e->add("Unable to convert start date \"".$start."\"", "error");
    return false;
   }

   if($end===false)
    $endTS=$this->grid->getEnd();
   else if(($endTS=$this->mutilate->dateConvert($end, $this->format))===false)
   {
    $this->e->add("Unable to convert end date \"".$end."\"", "error");
    return false;
   }

   if(!$interval)
    $interval=1;

   if(!$intervalHeader)
    $intervalHeader=$interval;

   if(!$type)
    $type="horizontal";

   if(!$headerFormat)
    $headerFormat=$this->format;

   //generate header
   $time=time();
   $this->grid->unsetEntries("header"); //clear previous header
   for($c=$startTS;$c<$endTS;$c+=$intervalHeader)
   {
    $this->grid->setEntry(date($headerFormat, $c), $c, $c+$intervalHeader, "header");

    if($c<=$time&&$time<$c+$intervalHeader)
     $this->grid->setClass("now");
   }

   $this->grid->setStart($startTS);
   $this->grid->setEnd($endTS);

   return $this->grid->render($type, $interval);
  }

 }

?>
